/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of FastSOM.xs. Do not edit this file, edit FastSOM.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "FastSOM.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <math.h>
#include "FastSOM.h"
#include "proto.h"

/*
 * generic funtions
 *
 * NOT superclass functions, but usable by all
 */

NV _vector_distance(AV* V1, AV* V2) {
	NV	diff,sum;
	I32	w_ptr;

	sum = 0;
	for ( w_ptr=av_len(V2) ; w_ptr>=0 ; w_ptr-- ) {
		diff = SvNV(*av_fetch(V1, w_ptr, FALSE))
			- SvNV(*av_fetch(V2, w_ptr, FALSE));
		sum += diff * diff;
	}
	return sqrt(sum);
}

void _bmuguts(SOM_GENERIC *som,AV *sample,IV *bx,IV *by,NV *bd) {
	IV		x,y,z,X,Y,Z;
	NV		sum,diff,distance;
	SOM_Map		*map;
	SOM_Array	*array;
	SOM_Vector	*vector;

	map = som->map;
	X = som->X;
	Y = som->Y;
	Z = som->Z;

	*bx = -1;
	*by = 0;
	*bd = 0.0;

	for ( x=0 ; x<X ; x++ ) {
		array = (&map->array)[x];
		for ( y=0 ; y<Y ; y++ ) {
			vector = (&array->vector)[y];

			sum = 0;
			for ( z=0 ; z<Z ; z++ ) {
				diff = SvNV(*av_fetch(sample,z,0))
					- (&vector->element)[z];
				sum += diff * diff;
			}

			distance = sqrt(sum);

			if ( *bx < 0 )
				{ *bx = 0; *by = 0; *bd = distance; }
			if ( distance < *bd )
				{ *bx = x; *by = y; *bd = distance; }
		}
	}
}


/* http://www.ai-junkie.com/ann/som/som4.html */
void _adjust(SV* self,NV l,NV sigma,AV* unit,AV* v) {
	IV		x,y;
	I32		z,Z;
	NV		d,theta,vold,wold;
	MAGIC		*mg;
	SOM_Map		*map;
	SOM_Array	*array;
	SOM_Vector	*vector;
	SOM_GENERIC	*som;

	x = SvIV(*av_fetch(unit, 0, FALSE));
	y = SvIV(*av_fetch(unit, 1, FALSE));
	d = SvNV(*av_fetch(unit, 2, FALSE));
	theta = exp( -d*d/2/sigma/sigma );

	if ( !(mg = selfmagic(self)) )
		croak("self has no magic!\n");
	som = self2somptr(self,mg);

	map = som->map;
	array = (&map->array)[x];
	vector = (&array->vector)[y];

	/* hmm.. casting IV to I32.. is that sane? */
	Z = (I32)som->Z;

	for ( z=0 ; z<Z ; z++ ) {
		wold = (&vector->element)[z];
		vold = SvNV(*av_fetch(v,z,FALSE));
		(&vector->element)[z] = (vold - wold) * l * theta + wold;
	}
}

void _adjustn(SOM_GENERIC* som,NV l,NV sigma,NV* n,AV* v) {
	IV		x,y,X,Y;
	I32		z,Z;
	NV		d,theta,vold,wold;
	SOM_Map		*map;
	SOM_Array	*array;
	SOM_Vector	*vector;

	map = som->map;
	X = som->X;
	Y = som->Y;

	for ( x=0 ; x<X ; x++ ) {
		array = (&map->array)[x];
		for ( y=0 ; y<Y ; y++ ) {
			d = n[x*Y+y];
			if (d < 0) continue;
			theta = exp( -d*d/2/sigma/sigma );
			vector = (&array->vector)[y];

			/* hmm.. casting IV to I32.. is that sane? */
			Z = (I32)som->Z;

			for ( z=0 ; z<Z ; z++ ) {
				wold = (&vector->element)[z];
				vold = SvNV(*av_fetch(v,z,FALSE));
				(&vector->element)[z] =
					(vold - wold) * l * theta + wold;
			}
		}
	}
}

AV* _neighbors(SV* self,NV sigma,IV X0,IV Y0,...) {
	IV		i,x,y,X,Y;
	NV		distance,*n;
	AV		*tmp,*neighbors;
	MAGIC		*mg;
	SOM_GENERIC	*som;
	void		(*neiguts)(SOM_GENERIC* som,NV sigma,IV X0,IV Y0,NV *n);

	if ( !(mg = selfmagic(self)) )
		croak("self has no magic!\n");
	som = self2somptr(self,mg);

	X = som->X;
	Y = som->Y;

	i = X*Y;
	Newx(n,i,NV);
	for ( i-=1 ; i>=0 ; i-- )
		n[i] = -1;

	if ( som->type == SOMType_Torus )
		neiguts = _torus_neiguts;
	else if ( som->type == SOMType_Hexa )
		neiguts = _hexa_neiguts;
	else if ( som->type == SOMType_Rect )
		neiguts = _rect_neiguts;
	else
		croak("unknown type");

	neiguts(som,sigma,X0,Y0,n);

	neighbors = newAV();

	for ( x=0 ; x<X ; x++ ) {
		for ( y=0 ; y<Y ; y++ ) {
			distance = n[x*Y+y];
			if ( distance >= 0 ) {
				tmp = newAV();
				av_push(tmp,newSViv(x));
				av_push(tmp,newSViv(y));
				av_push(tmp,newSVnv(distance));
				av_push(neighbors,newRV_noinc((SV*)tmp));
			}
		}
	}
	Safefree(n);
	return neighbors;
}

SOM_Vector* _make_vector(SOM_Array* array) {
	IV		z,len;
	AV		*thingy;
	SV		*tie;
	HV		*stash;
	SOM_Vector	*vector;

        z = array->Z;

	len = sizeof(SOM_Vector)+z*sizeof(NV);
        Newxc(vector, len, char, SOM_Vector);
	Zero(vector, len, char);

        vector->Z = z;

        thingy = newAV();
        tie = newRV_noinc(newSViv(PTR2IV(vector)));
        stash = gv_stashpv("AI::NeuralNet::FastSOM::VECTOR", GV_ADD);
        sv_bless(tie, stash);
        hv_magic((HV*)thingy, (GV*)tie, 'P');
	vector->ref = newRV_noinc((SV*)thingy);

        (&vector->element)[z] = 0.0;
        for ( z-=1 ; z>=0 ; z-- ) {
                (&vector->element)[z] = 0.0;
        }

        return vector;
}

SOM_Array* _make_array(SOM_Map* map) {
	IV		y,len;
	AV		*thingy;
	SV		*tie;
	HV		*stash;
	SOM_Array	*array;

	y = map->Y;

	len = sizeof(SOM_Array)+y*sizeof(SOM_Vector*);
	Newxc(array, len, char, SOM_Array);
	Zero(array, len, char);

	array->Y = y;
	array->Z = map->Z;

	thingy = newAV();
	tie = newRV_noinc(newSViv(PTR2IV(array)));
	stash = gv_stashpv("AI::NeuralNet::FastSOM::ARRAY", GV_ADD);
	sv_bless(tie, stash);
	hv_magic((HV*)thingy, (GV*)tie, PERL_MAGIC_tied);
	array->ref = newRV_noinc((SV*)thingy);

	(&array->vector)[y] = NULL;
	for ( y-=1 ; y>=0 ; y-- )
		(&array->vector)[y] = _make_vector( array );

	return array;
}

SOM_Map* _make_map(SOM_GENERIC *som) {
	IV	x,len;
	AV	*thingy;
	SV	*tie;
	HV	*stash;
	SOM_Map	*map;

	x = som->X;

	len = sizeof(SOM_Map)+x*sizeof(SOM_Array*);
	Newxc(map, len, char, SOM_Map);
	Zero(map, len, char);

	map->X = x;
	map->Y = som->Y;
	map->Z = som->Z;

	thingy = newAV();
	tie = newRV_noinc(newSViv(PTR2IV(map)));
	stash = gv_stashpv("AI::NeuralNet::FastSOM::MAP", GV_ADD);
	sv_bless(tie, stash);
	hv_magic((HV*)thingy, (GV*)tie, PERL_MAGIC_tied);
	map->ref = newRV_noinc((SV*)thingy);

	(&map->array)[x] = NULL;
	for ( x-=1 ; x>=0 ; x-- )
		(&map->array)[x] = _make_array( map );

	return map;
}



/*
 * som functions
 */

void _som_bmu(SV* self, AV* sample) {
	IV		cx,cy;
	NV		cd;
	MAGIC		*mg;
	SOM_GENERIC	*som;
	dXSARGS;

	if ( !(mg = selfmagic(self)) )
		croak("self has no magic!\n");
	som = self2somptr(self,mg);

	_bmuguts(som,sample,&cx,&cy,&cd);

	PERL_UNUSED_VAR(items); /* -W */
	sp = mark;
	XPUSHs(sv_2mortal(newSViv(cx)));
	XPUSHs(sv_2mortal(newSViv(cy)));
	XPUSHs(sv_2mortal(newSVnv(cd)));
	PUTBACK;
}

SV* _som_map(SV* self) {
        MAGIC		*mg;
	SOM_GENERIC	*som;

	if ( !(mg = selfmagic(self)) )
                croak("self has no magic!\n");
	som = self2somptr(self,mg);

	SvREFCNT_inc(som->map->ref);
	return som->map->ref;
}

SV* _som_output_dim(SV* self) {
	MAGIC		*mg;
	SOM_GENERIC	*som;

	if ( !(mg = selfmagic(self)) )
		croak("self has no magic!\n");
	som = self2somptr(self,mg);

	SvREFCNT_inc(som->output_dim);
	return som->output_dim;
}

void _som_train(SV* self,IV epochs) {
	IV		i,X,Y,bx,by,epoch;
	NV		bd,l,sigma,*n;
	AV		**org,**veg,*sample;
	I32		p,pick,nitems,oitems,vitems;
	MAGIC		*mg;
	SOM_GENERIC	*som;
	bool		wantarray;
	void		(*neiguts)(SOM_GENERIC* som,NV sigma,IV X0,IV Y0,NV* n);
	dXSARGS;

	if ( !(mg = selfmagic(self)) )
		croak("self has no magic!");
	som = self2somptr(self,mg);

	if ( epochs < 1 )
		epochs = 1;

	if ( items < 3 )
		croak("no data to learn");

	oitems = items - 2;
	Newx(org,oitems,AV*);
	Newx(veg,oitems,AV*);

	for ( i=2 ; i<items ; i++ )
		if ( SvTYPE(SvRV(ST(i))) != SVt_PVAV )
			croak("training item %i is not an array ref", (int)i);
		else
			org[i-2] = (AV*)SvRV(ST(i));

	som->LAMBDA = epochs / log( som->Sigma0 );

	X = som->X;
	Y = som->Y;

	nitems = X*Y;
	Newx(n,nitems,NV);

	if ( som->type == SOMType_Torus )
		neiguts = _torus_neiguts;
	else if ( som->type == SOMType_Hexa )
		neiguts = _hexa_neiguts;
	else if ( som->type == SOMType_Rect )
		neiguts = _rect_neiguts;
	else
		croak("unknown type");

	wantarray = GIMME_V == G_ARRAY ? TRUE : FALSE;

	/* should this be moved somewhere more global? */
	if ( !PL_srand_called ) {
		seedDrand01((Rand_seed_t)(time(NULL)+PerlProc_getpid()));
		PL_srand_called = TRUE;
	}

	sp = mark;

	for ( epoch=1 ; epoch<=epochs ; epoch++ ) {
		som->T = epoch;
		sigma = som->Sigma0 * exp(-epoch / som->LAMBDA);
		l = som->L0 * exp(-epoch / epochs);

		Copy(org,veg,oitems,AV*);
		vitems = oitems;

		while ( vitems > 0 ) {

			pick = (I32)(Drand01() * vitems);

			sample = (AV*)veg[pick];

			/* optimize me! */
			for ( p=pick+1 ; p<vitems ; p++ ) veg[p-1] = veg[p];
			vitems--;

			_bmuguts(som,sample,&bx,&by,&bd);

			if ( wantarray ) XPUSHs(newSVnv(bd));

			for ( i=0 ; i<nitems ; i++ ) n[i] = -1;

			neiguts(som,sigma,bx,by,n);

			_adjustn(som,l,sigma,n,sample);

		}
	}

	Safefree(n);
	Safefree(org);
	Safefree(veg);

	PUTBACK;
}

void _som_FREEZE(SV* self,SV* cloning) {
	IV		x,y,z;
	MAGIC		*mg;
	SOM_Map		*m;
	SOM_Array	*a;
	SOM_Vector	*v;
	SOM_GENERIC	*som;
	dXSARGS;

	PERL_UNUSED_VAR(items); /* -W */
	sp = mark;

	if ( !SvTRUE(cloning) ) {

	if ( (mg = selfmagic(self)) != NULL) {

		/*
		 * we should get here on the first pass. this is where we
		 * serialize the hash seen from perl.
		 */

		XPUSHs(INT2PTR(SV*,newSVpvn("i wanna be a cowboy",19)));

	}
	else if ( SvTYPE(SvRV(self)) == SVt_PVMG ) {

		/*
		 * this should be the second pass. here we need to serialize
		 * the tied part not seen from the perl side.
		 */

		som = INT2PTR(SOM_GENERIC*,self2iv(self));

		XPUSHs( INT2PTR(SV*,newSVpvn(
				"beat me whip me make me code badly",34)) );
		XPUSHs( newRV_noinc(newSViv(som->type)) );
		XPUSHs( newRV_noinc(newSViv(som->X)) );
		XPUSHs( newRV_noinc(newSViv(som->Y)) );
		XPUSHs( newRV_noinc(newSViv(som->Z)) );
		XPUSHs( newRV_noinc(newSVnv(som->R)) );
		XPUSHs( newRV_noinc(newSVnv(som->Sigma0)) );
		XPUSHs( newRV_noinc(newSVnv(som->L0)) );
		XPUSHs( newRV_noinc(newSVnv(som->LAMBDA)) );
		XPUSHs( newRV_noinc(newSVnv(som->T)) );
		XPUSHs( newRV_noinc(som->output_dim) );
		XPUSHs( newRV_noinc((SV*)som->labels) );

		m = som->map;
		for ( x=som->X-1 ; x>=0 ; x-- ) {
			a = (&m->array)[x];
			for ( y=som->Y-1 ; y>=0 ; y-- ) {
				v = (&a->vector)[y];
				for ( z=som->Z-1 ; z>=0 ; z-- ) {
					XPUSHs(newRV_noinc(newSVnv(
					(&v->element)[z])));
				}
			}
		}
	}
	else {
		croak("i wanna run with scissors!");
	}
	} /* cloning */
	PUTBACK;
}

void _som_THAW(SV* self,SV* cloning,SV* serialized) {
	IV		x,y,z,i;
	SV		*rrr;
	HV		*stash;
	SOM_Map		*m;
	SOM_Array	*a;
	SOM_Vector	*v;
	SOM_GENERIC	*som;
	dXSARGS;

	PERL_UNUSED_VAR(serialized); /* -W */

	if (!SvTRUE(cloning)) {

	if ( SvTYPE(SvRV(self)) == SVt_PVMG ) {
		Newxz(som,1,SOM_GENERIC);

		som->type = SvIV(SvRV(ST(3)));
		som->X = SvIV(SvRV(ST(4)));
		som->Y = SvIV(SvRV(ST(5)));
		som->Z = SvIV(SvRV(ST(6)));
		som->R = SvNV(SvRV(ST(7)));
		som->Sigma0 = SvNV(SvRV(ST(8)));
		som->L0 = SvNV(SvRV(ST(9)));
		som->LAMBDA = SvNV(SvRV(ST(10)));
		som->T = SvNV(SvRV(ST(11)));
		som->output_dim = newSVsv(SvRV(ST(12)));
		som->labels = (AV*)SvRV(ST(13));

		som->map = _make_map( som );

		i = 14;
		m = som->map;
		for ( x=som->X-1 ; x>=0 ; x-- ) {
			a = (&m->array)[x];
			for ( y=som->Y-1 ; y>=0 ; y-- ) {
				v = (&a->vector)[y];
				for ( z=som->Z-1 ; z>=0 ; z-- ) {
					/*
					(&v->element)[z] =
						SvNV(SvRV(ST(i++)));
					*/
					rrr = SvRV(ST(i++));
					(&v->element)[z] = SvNV(rrr);
				}
			}
		}

		SvSetSV( SvRV(self), sv_2mortal(newSViv((IV)PTR2IV(som))) );

		stash = SvSTASH(SvRV(self));
		som->ref = sv_bless(newRV_inc((SV*)self),stash);

	}

	else if ( SvTYPE(SvRV(self)) != SVt_PVHV )
		croak("you'll put an eye out!");

	} /* cloning */

	PERL_UNUSED_VAR(items); /* -W */
	sp = mark;
	PUTBACK;
}

SV* _som_FETCH(SV* self,SV* key) {
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("map",3) ) ) ) {
		SOM_GENERIC *som = INT2PTR(SOM_Rect*,self2iv(self));
		SvREFCNT_inc(som->map->ref);
		return som->map->ref;
	}
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_X",2) ) ) )
		return newSViv(tied2ptr(self)->X);
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_Y",2) ) ) )
		return newSViv(tied2ptr(self)->Y);
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_Z",2) ) ) )
		return newSViv(tied2ptr(self)->Z);
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_R",2) ) ) )
		return newSVnv(tied2ptr(self)->R);
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_L0",3) ) ) )
		return newSVnv(tied2ptr(self)->L0);
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_Sigma0",7) ) ) )
		return newSVnv(tied2ptr(self)->Sigma0);
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("output_dim",10) ) ) )
		return newSVsv(tied2ptr(self)->output_dim);
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("LAMBDA",6) ) ) )
		return newSVnv(tied2ptr(self)->LAMBDA);
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("T",1) ) ) )
		return newSVnv(tied2ptr(self)->T);
	if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("labels",6) ) ) )
		return newRV_inc((SV*)(tied2ptr(self)->labels));
	croak("%s not accessible for read", SvPV_nolen(key));
}

SV* _som_STORE(SV* self,SV* key,SV* val) {
        if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_X",2) ) ) )
		tied2ptr(self)->X = SvIV(val);
        else if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_Y",2) ) ) )
                tied2ptr(self)->Y = SvIV(val);
        else if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_Z",2) ) ) )
                tied2ptr(self)->Z = SvIV(val);
        else if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_R",2) ) ) )
                tied2ptr(self)->R = SvNV(val);
	else if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_L0",3) ) ) )
		tied2ptr(self)->L0 = SvNV(val);
        else if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("_Sigma0",7) ) ) )
                tied2ptr(self)->Sigma0 = SvNV(val);
        else if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("output_dim",10) ) ) )
                tied2ptr(self)->output_dim = newSVsv(val);
	else if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("LAMBDA",6) ) ) )
		tied2ptr(self)->LAMBDA = SvNV(val);
	else if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("T",1) ) ) )
		tied2ptr(self)->T = SvNV(val);
        else if ( !sv_cmp( key, INT2PTR(SV*,newSVpvn("map",3) ) ) )
		croak("cant assign to map");
	else
		croak("%s not accessible for write", SvPV_nolen(key));
	return val;
}

SV* _som_FIRSTKEY() {
	return INT2PTR(SV*,newSVpvn("_X",2));
}

SV* _som_NEXTKEY(SV* prev) {
        if ( strEQ( SvPVX(prev), "_X" ) )
                return INT2PTR(SV*,newSVpvn("_Y",2));
        else if ( strEQ( SvPVX(prev), "_Y" ) )
                return INT2PTR(SV*,newSVpvn("_Z",2));
        else if ( strEQ( SvPVX(prev), "_Z" ) )
                return INT2PTR(SV*,newSVpvn("_R",2));
        else if ( strEQ( SvPVX(prev), "_R" ) )
                return INT2PTR(SV*,newSVpvn("_Sigma0",7));
        else if ( strEQ( SvPVX(prev), "_Sigma0" ) )
                return INT2PTR(SV*,newSVpvn("_L0",3));
        else if ( strEQ( SvPVX(prev), "_L0" ) )
                return INT2PTR(SV*,newSVpvn("LAMBDA",6));
        else if ( strEQ( SvPVX(prev), "LAMBDA" ) )
                return INT2PTR(SV*,newSVpvn("T",1));
        else if ( strEQ( SvPVX(prev), "T" ) )
                return INT2PTR(SV*,newSVpvn("labels",6));
        else if ( strEQ( SvPVX(prev), "labels" ) )
                return INT2PTR(SV*,newSVpvn("map",3));
        return &PL_sv_undef;
}

void _som_DESTROY(SV* self) {
	IV              iv;
	SV              *ref;
	SOM_Map         *map;
	SOM_GENERIC     *som;

	if ( !SvROK(self) )
		return;
	ref = SvRV(self);
	if ( !SvIOK(ref) )
		return;
	iv = SvIV(ref);
	som = INT2PTR(SOM_GENERIC*,iv);
	if ( !som )
		return;
	map = som->map;
	/* more to do here ? */
}



/*
 * rect functions
 */

void _rect_neiguts(SOM_Rect* som,NV sigma,IV X0,IV Y0,NV* n) {
	IV	x,y,X,Y;
	NV	d2,s2;

	X = som->X;
	Y = som->Y;

	s2 = sigma * sigma;

	for ( x=0 ; x<X ; x++ ) {
		for ( y=0 ; y<Y ; y++ ) {
			d2 = (x-X0)*(x-X0)+(y-Y0)*(y-Y0);
			if (d2 <= s2) n[x*Y+y] = sqrt(d2);
		}
	}
}

void _rect_new(const char* class,...) {
	IV		i;
	NV		sigma0,rate;
	SV		*tie,*rv,*key,*val,*od,*sclass;
	HV		*options,*hash,*stash;
	char		*begptr,*endptr,*xstart,*ystart,*yend;
	STRLEN		len;
	SOM_GENERIC	*som;
	dXSARGS;

	if ( (items & 1) ^ 1 )
		croak( "Weird number of arguments\n" );

	options = newHV();
	for ( i=1 ; i<items ; i+=2 ) {
		key = ST(i);
		val = ST(i+1);
		len = sv_len(key);
		hv_store( options, SvPV_nolen(key), len, val, 0 );
	}

	if ( !hv_exists( options, "input_dim", 9 ) )
		croak( "no input_dim argument" );
	if ( !hv_exists( options, "output_dim", 10 ) )
		croak( "no output_dim argument" );

	Newxz(som,1,SOM_GENERIC);

	od = newSVsv(*hv_fetch(options,"output_dim",10,FALSE));
	som->output_dim = od;

	begptr = SvPV_force(od,SvLEN(od));
	endptr = SvEND(od) - 1; /* allow for terminating character */
	if ( endptr < begptr )
		croak("brain damage!!!");

	xstart = begptr;
	if ( !isDIGIT((char)*xstart) )
		croak("no x-dimension found");
	som->X = Atol(xstart);

	ystart = yend = endptr;
	if ( !isDIGIT((char)*ystart) )
		croak("no y-dimension found");
	while (--ystart >= begptr)
		if ( !isDIGIT((char)*ystart) )
			break;
	som->Y = Atol(++ystart);

	som->Z = SvIV(*hv_fetch(options,"input_dim",9,FALSE));

	som->R = som->X > som->Y
		? som->Y / 2.0
		: som->X / 2.0;

	if ( hv_exists( options, "sigma0", 6 ) ) {
		sigma0 = SvNV(*hv_fetch(options,"sigma0",6,0));
		if ( sigma0 )
			som->Sigma0 = sigma0;
		else
			som->Sigma0 = som->R;
	}
	else
		som->Sigma0 = som->R;

	if ( hv_exists( options, "learning_rate", 13 ) ) {
		rate = SvNV(*hv_fetch(options,"learning_rate",13,0));
		if ( rate )
			som->L0 = rate;
		else
			som->L0 = 0.1;
	}
	else
		som->L0 = 0.1;

	som->map = _make_map(som);
	som->labels = newAV();

	sclass = sv_2mortal(newSVpvf("%s",class));
	if (!sv_cmp(sclass,INT2PTR(
			SV*,newSVpvn("AI::NeuralNet::FastSOM::Rect",28))))
		som->type = SOMType_Rect;
	/*
	else if (!sv_cmp(sclass,INT2PTR(
			SV*,newSVpvn("AI::NeuralNet::FastSOM::Hexa",28))))
		som->type = SOMType_Hexa;
	*/
	else if (!sv_cmp(sclass,INT2PTR(
			SV*,newSVpvn("AI::NeuralNet::FastSOM::Torus",29))))
		som->type = SOMType_Torus;
	else
		croak("unknown type");

	hash = (HV*)sv_2mortal((SV*)newHV());
	tie = newRV_noinc(newSViv(PTR2IV(som)));
	stash = gv_stashpv(class, GV_ADD);
	sv_bless(tie, stash);
	hv_magic(hash, (GV*)tie, PERL_MAGIC_tied);
	rv = sv_bless(newRV_noinc((SV*)hash),stash);

	som->ref = rv;

	/*
	 * here 'hash' is the object seen from the perl side.
	 * 'tie' is what we see from the c side when accessing the tied
	 * functionality.
	 */

	sp = mark;
	XPUSHs(rv);
	PUTBACK;
}

SV* _rect_radius(SV* self) {
	MAGIC		*mg;
	SOM_GENERIC	*som;

	if ( !(mg = selfmagic(self)) )
		croak("self has no magic!\n");
	som = self2somptr(self,mg);

	return newSVnv(som->R);
}



/*
 * torus functions
 */

void _torus_neiguts(SOM_Torus* som,NV sigma,IV X0,IV Y0,NV* n) {
	IV	x,y,X,Y;
	NV	d2,s2;

	X = som->X;
	Y = som->Y;

	s2 = sigma * sigma;

	for ( x=0 ; x<X ; x++ ) {
		for ( y=0 ; y<Y ; y++ ) {

			/*
			 * which one of these should "win"?
			 */

			d2 = (x-X0)*(x-X0) + (y-Y0)*(y-Y0);
			if (d2 <= s2) n[x*Y+y] = sqrt(d2);

			d2 = (x-X-X0)*(x-X-X0) + (y-Y0)*(y-Y0);
			if (d2 <= s2) n[x*Y+y] = sqrt(d2);

			d2 = (x+X-X0)*(x+X-X0) + (y-Y0)*(y-Y0);
			if (d2 <= s2) n[x*Y+y] = sqrt(d2);

			d2 = (x-X0)*(x-X0) + (y-Y-Y0)*(y-Y-Y0);
			if (d2 <= s2) n[x*Y+y] = sqrt(d2);

			d2 = (x-X0)*(x-X0) + (y+Y-Y0)*(y+Y-Y0);
			if (d2 <= s2) n[x*Y+y] = sqrt(d2);
		}
	}
}

/* http://www.ai-junkie.com/ann/som/som3.html */



/*
 * hexa functions
 */

void _hexa_new(const char* class) {
	IV		i;
	SV		*key,*val,*od,*tie,*rv;
	NV		sigma0,rate;
	HV		*options,*hash,*stash;
	STRLEN		len;
	SOM_Hexa	*hexa;
	dXSARGS;

	if ( (items & 1) ^ 1 )
		croak( "Weird number of arguments\n" );

	options = newHV();
	for ( i=1 ; i<items ; i+=2 ) {
		key = ST(i);
		val = ST(i+1);
		len = sv_len(key);
		hv_store( options, SvPV_nolen(key), len, val, 0 );
	}

	if ( !hv_exists( options, "input_dim", 9 ) )
		croak( "no input_dim argument" );
	if ( !hv_exists( options, "output_dim", 10 ) )
		croak( "no ouput_dim argument" );

	Newxz(hexa,1,SOM_Hexa);

	od = newSVsv(*hv_fetch(options,"output_dim",10,FALSE));
	hexa->output_dim = od;

	hexa->X=SvIV(*hv_fetch(options,"output_dim",10,FALSE));
	hexa->Z=SvIV(*hv_fetch(options,"input_dim",9,FALSE));

	hexa->Y = hexa->X;
	hexa->R = hexa->X / 2.0;

	if ( hv_exists( options, "sigma0", 6 ) ) {
		sigma0 = SvNV(*hv_fetch(options,"sigma0",6,0));
                if ( sigma0 )
                        hexa->Sigma0 = sigma0;
                else
                        hexa->Sigma0 = hexa->R;
        }
        else
                hexa->Sigma0 = hexa->R;

	if ( hv_exists( options, "learning_rate", 13 ) ) {
                rate = SvNV(*hv_fetch(options,"learning_rate",13,0));
                if ( rate )
                        hexa->L0 = rate;
                else
                        hexa->L0 = 0.1;
        }
        else
                hexa->L0 = 0.1;

	hexa->map = _make_map( hexa );
	hexa->labels = newAV();

	hexa->type = SOMType_Hexa;

	hash = (HV*)sv_2mortal((SV*)newHV());
	tie = newRV_noinc(newSViv(PTR2IV(hexa)));
	stash = gv_stashpv(class, GV_ADD);
	sv_bless(tie, stash);
	hv_magic(hash, (GV*)tie, PERL_MAGIC_tied);
	rv = sv_bless(newRV_noinc((SV*)hash),stash);

	hexa->ref = rv;

	sp = mark;
	XPUSHs(rv);
	PUTBACK;
}

NV _hexa_distance(NV x1,NV y1,NV x2,NV y2) {
	NV	tmp,dx,dy;

	if ( x1+y1 > x2+y2 ) {
		tmp=x1; x1=x2; x2=tmp;
		tmp=y1; y1=y2; y2=tmp;
	}

	dx = x2 - x1;
	dy = y2 - y1;

	if ( dx<0 || dy<0 )
		return abs(dx) + abs(dy);
	else
		return dx<dy ? dy : dx;
}

void _hexa_neiguts(SOM_Hexa* som,NV sigma,IV X0,IV Y0,NV* n) {
	IV	x,y,X,Y;
	NV	d;

	X = som->X;
	Y = som->Y;

	for ( x=0 ; x<X ; x++ ) {
		for ( y=0 ; y<Y ; y++ ) {
			d = _hexa_distance(X0,Y0,x,y);
			if (d <= sigma) n[x*Y+y] = d;
		}
	}
}



/*
 * map functions
 */

SV* _map_FETCH(SV* self,I32 x) {
	SOM_Map		*map;
	SOM_Array	*array;
	
	map = INT2PTR(SOM_Map*,self2iv(self));
	array = (&map->array)[x];
	SvREFCNT_inc(array->ref);
	return array->ref;
}

void _map_DESTROY(SV* self) {
	SOM_Map		*map;

	map = INT2PTR(SOM_Map*,self2iv(self));
	/* need more done here ? */
	Safefree( map );
}



/*
 * array functions
 */

void _array_STORE(SV* self,IV y,SV* aref) {
	I32		len;
	NV		tmp;
	AV		*src;
	SV		**ptr;
	SOM_Array	*array;
	SOM_Vector	*dst;

	if ( SvTYPE( SvRV(aref) ) != SVt_PVAV )
		croak("value to store is not a reference to an array\n");
	src = (AV*)SvRV( aref );

	array = INT2PTR(SOM_Array*,self2iv(self));
	dst = (&array->vector)[y];

	if ( y < 0 )
		croak("storing y-index < 0 not supported\n");
	if ( y >= array->Y )
		croak("storing y-index > y-dimension of SOM\n");

	len = av_len( src );
	if ( len < 0 )
		croak("cant store empty vector\n");
	if ( len+1 > array->Z )
		croak("vector too long\n");
	if ( len+1 < array->Z )
		croak("vector too short\n");

	for ( ; len >= 0 ; len-- ) {
		ptr = av_fetch( src, len, 0 );
		if ( ptr == NULL )
			croak("NULL ptr!\n");
		tmp = SvNV(*ptr);
		(&dst->element)[len] = tmp;
	}
}

SV* _array_FETCH(SV* self,I32 y) {
	SOM_Array	*array;
	SOM_Vector	*vector;

	array = INT2PTR(SOM_Array*,self2iv(self));
	vector = (&array->vector)[y];
	SvREFCNT_inc(vector->ref);
	return vector->ref;
}

void _array_DESTROY(SV* self) {
	SOM_Array	*array;

	array = INT2PTR(SOM_Array*,self2iv(self));
	/* need more done here ? */
	Safefree( array );
}



/*
 * vector functions
 */

void _vector_STORE(SV* self,I32 z,NV val) {
	SOM_Vector	*vector;

	vector = INT2PTR(SOM_Vector*,self2iv(self));
	if ( z < 0 )
		croak("negative z-index not supported\n");
	if ( z >= vector->Z )
		croak("z-index larger than vector dimension\n");
	(&vector->element)[z] = val;
}

SV* _vector_FETCH(SV* self,I32 z) {
	SOM_Vector	*vector;

	vector = INT2PTR(SOM_Vector*,self2iv(self));
	return newSVnv((&vector->element)[z]);
}

void _vector_DESTROY(SV* self) {
	SOM_Vector	*vector;

	vector = INT2PTR(SOM_Vector*,self2iv(self));
	/* need more done here ? */
	Safefree( vector );
}



/*
 *
 * End of C code. Begin XS.
 *
 */



#line 1091 "FastSOM.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 1235 "FastSOM.c"

XS_EUPXS(XS_AI__NeuralNet__FastSOM_train); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_train)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "self, epochs, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	IV	epochs = (IV)SvIV(ST(1))
;
#line 1091 "FastSOM.xs"
	I32* temp;
#line 1252 "FastSOM.c"
#line 1093 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_som_train(self,epochs);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
	}
	return;
#line 1261 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_bmu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_bmu)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, sample");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	AV *	sample;
#line 1106 "FastSOM.xs"
	I32* temp;
#line 1282 "FastSOM.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    sample = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"AI::NeuralNet::FastSOM::bmu",
				"sample");
		}
	} STMT_END
;
#line 1108 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_som_bmu(self,sample);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
        }
	return;
#line 1305 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_map); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_map)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1120 "FastSOM.xs"
	SV* rv;
#line 1323 "FastSOM.c"
	SV *	RETVAL;
#line 1122 "FastSOM.xs"
	rv = _som_map(self);
	ST(0) = rv;
	sv_2mortal(ST(0));
#line 1329 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_output_dim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_output_dim)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1130 "FastSOM.xs"
	SV* rv;
#line 1346 "FastSOM.c"
	SV *	RETVAL;
#line 1132 "FastSOM.xs"
	rv = _som_output_dim(self);
	ST(0) = rv;
	sv_2mortal(ST(0));
#line 1352 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__adjust); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__adjust)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self, l, sigma, unit, v");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	NV	l = (NV)SvNV(ST(1))
;
	NV	sigma = (NV)SvNV(ST(2))
;
	AV *	unit;
	AV *	v;
#line 1144 "FastSOM.xs"
	I32* temp;
#line 1377 "FastSOM.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(3);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    unit = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"AI::NeuralNet::FastSOM::_adjust",
				"unit");
		}
	} STMT_END
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(4);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    v = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"AI::NeuralNet::FastSOM::_adjust",
				"v");
		}
	} STMT_END
;
#line 1146 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_adjust(self, l, sigma, unit, v);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
	}
	return;
#line 1414 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_STORABLE_freeze); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_STORABLE_freeze)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, cloning");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	SV *	cloning = ST(1)
;
#line 1159 "FastSOM.xs"
	I32* temp;
#line 1436 "FastSOM.c"
#line 1161 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_som_FREEZE(self,cloning);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
	}
	return;
#line 1445 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_STORABLE_thaw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_STORABLE_thaw)
{
    dVAR; dXSARGS;
    if (items < 3)
       croak_xs_usage(cv,  "self, cloning, serialized, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	SV *	cloning = ST(1)
;
	SV *	serialized = ST(2)
;
#line 1175 "FastSOM.xs"
	I32* temp;
#line 1469 "FastSOM.c"
#line 1177 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_som_THAW(self,cloning,serialized);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_UNDEF;
	}
	return;
#line 1478 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, key");
    {
	SV *	self = ST(0)
;
	SV *	key = ST(1)
;
#line 1190 "FastSOM.xs"
	SV* rv;
#line 1498 "FastSOM.c"
	SV *	RETVAL;
#line 1192 "FastSOM.xs"
	rv = _som_FETCH(self, key);
	ST(0) = rv;
	sv_2mortal(ST(0));
#line 1504 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, key, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	SV *	key = ST(1)
;
	SV *	val = ST(2)
;
#line 1202 "FastSOM.xs"
	I32* temp;
#line 1527 "FastSOM.c"
#line 1204 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_som_STORE(self, key, val);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
	}
	return;
#line 1536 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_FIRSTKEY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1216 "FastSOM.xs"
	SV* rv;
#line 1554 "FastSOM.c"
	SV *	RETVAL;
#line 1218 "FastSOM.xs"
	if (!self) croak("avoiding -Wextra");
        rv = _som_FIRSTKEY();
        ST(0) = rv;
        sv_2mortal(ST(0));
#line 1561 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_NEXTKEY)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, prev");
    {
	SV *	self = ST(0)
;
	SV *	prev = ST(1)
;
#line 1228 "FastSOM.xs"
	SV* rv;
#line 1580 "FastSOM.c"
	SV *	RETVAL;
#line 1230 "FastSOM.xs"
	if (!self) croak("avoiding -Wextra");
        rv = _som_NEXTKEY(prev);
        ST(0) = rv;
        sv_2mortal(ST(0));
#line 1587 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	obj = ST(0)
;
#line 1239 "FastSOM.xs"
	I32* temp;
#line 1606 "FastSOM.c"
#line 1241 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_som_DESTROY(obj);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
	}
	return;
#line 1615 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__Rect_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__Rect_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	class = (const char *)SvPV_nolen(ST(0))
;
#line 1260 "FastSOM.xs"
	I32* temp;
#line 1635 "FastSOM.c"
#line 1262 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_rect_new(class);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
        }
	return;
#line 1644 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__Rect_neighbors); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__Rect_neighbors)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "self, sigma, X, Y, ...");
    {
	SV *	self = ST(0)
;
	NV	sigma = (NV)SvNV(ST(1))
;
	IV	X = (IV)SvIV(ST(2))
;
	IV	Y = (IV)SvIV(ST(3))
;
#line 1277 "FastSOM.xs"
        I32* temp;
#line 1668 "FastSOM.c"
	AV *	RETVAL;
#line 1279 "FastSOM.xs"
        temp = PL_markstack_ptr++;
        RETVAL = _neighbors(self, sigma, X, Y);
        PL_markstack_ptr = temp;
#line 1674 "FastSOM.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__Rect_radius); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__Rect_radius)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1289 "FastSOM.xs"
	SV* rv;
#line 1697 "FastSOM.c"
	SV *	RETVAL;
#line 1291 "FastSOM.xs"
	rv = _rect_radius(self);
	ST(0) = rv;
	sv_2mortal(ST(0));
#line 1703 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__Torus_neighbors); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__Torus_neighbors)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "self, sigma, X, Y, ...");
    {
	SV *	self = ST(0)
;
	NV	sigma = (NV)SvNV(ST(1))
;
	IV	X = (IV)SvIV(ST(2))
;
	IV	Y = (IV)SvIV(ST(3))
;
#line 1310 "FastSOM.xs"
        I32* temp;
#line 1726 "FastSOM.c"
	AV *	RETVAL;
#line 1312 "FastSOM.xs"
        temp = PL_markstack_ptr++;
        RETVAL = _neighbors(self, sigma, X, Y);
        PL_markstack_ptr = temp;
#line 1732 "FastSOM.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__Hexa_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__Hexa_new)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	const char *	class = (const char *)SvPV_nolen(ST(0))
;
#line 1329 "FastSOM.xs"
	I32* temp;
#line 1757 "FastSOM.c"
#line 1331 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_hexa_new(class);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
        }
	return;
#line 1766 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__Hexa_neighbors); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__Hexa_neighbors)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "self, sigma, X, Y, ...");
    {
	SV *	self = ST(0)
;
	NV	sigma = (NV)SvNV(ST(1))
;
	IV	X = (IV)SvIV(ST(2))
;
	IV	Y = (IV)SvIV(ST(3))
;
#line 1346 "FastSOM.xs"
        I32* temp;
#line 1790 "FastSOM.c"
	AV *	RETVAL;
#line 1348 "FastSOM.xs"
        temp = PL_markstack_ptr++;
        RETVAL = _neighbors(self, sigma, X, Y);
        PL_markstack_ptr = temp;
#line 1796 "FastSOM.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__Utils_vector_distance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__Utils_vector_distance)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "V1, V2");
    {
	AV_SPECIAL*	V1;
	AV_SPECIAL*	V2;
#line 1366 "FastSOM.xs"
	NV rv;
#line 1819 "FastSOM.c"
	NV	RETVAL;
	dXSTARG;

	if (SvTYPE(ST(0))==SVt_PVLV && SvRMAGICAL(ST(0)) && mg_find(ST(0),'p'))
		mg_get(ST(0));
	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0)))==SVt_PVAV)
		V1 = (AV*)SvRV(ST(0));
	else
		Perl_croak(aTHX_ "%s: %s is not a magical array reference",
			"AI::NeuralNet::FastSOM::Utils::vector_distance",
			"V1")
;

	if (SvTYPE(ST(1))==SVt_PVLV && SvRMAGICAL(ST(1)) && mg_find(ST(1),'p'))
		mg_get(ST(1));
	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVAV)
		V2 = (AV*)SvRV(ST(1));
	else
		Perl_croak(aTHX_ "%s: %s is not a magical array reference",
			"AI::NeuralNet::FastSOM::Utils::vector_distance",
			"V2")
;
#line 1368 "FastSOM.xs"
        rv = _vector_distance((AV*)V1, (AV*)V2);
        XSprePUSH; PUSHn((NV)rv);
#line 1845 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__MAP_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__MAP_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, x");
    {
	SV *	self = ST(0)
;
	I32	x = (I32)SvIV(ST(1))
;
#line 1383 "FastSOM.xs"
	SV* rv;
#line 1864 "FastSOM.c"
	SV *	RETVAL;
#line 1385 "FastSOM.xs"
	rv = _map_FETCH(self, x);
	ST(0) = rv;
	sv_2mortal(ST(0));
#line 1870 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__MAP_FETCHSIZE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__MAP_FETCHSIZE)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1393 "FastSOM.xs"
	IV rv;
#line 1887 "FastSOM.c"
	IV	RETVAL;
	dXSTARG;
#line 1395 "FastSOM.xs"
	rv = (INT2PTR(SOM_Map*,self2iv(self)))->X;
	XSprePUSH; PUSHi((IV)rv);
#line 1893 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__MAP_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__MAP_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	obj = ST(0)
;
#line 1402 "FastSOM.xs"
	I32* temp;
#line 1912 "FastSOM.c"
#line 1404 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_map_DESTROY(obj);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
        }
	return;
#line 1921 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__ARRAY_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__ARRAY_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, y, aref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	IV	y = (IV)SvIV(ST(1))
;
	SV *	aref = ST(2)
;
#line 1425 "FastSOM.xs"
	I32* temp;
#line 1945 "FastSOM.c"
#line 1427 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_array_STORE(self, y, aref);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
        }
	return;
#line 1954 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__ARRAY_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__ARRAY_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, y");
    {
	SV *	self = ST(0)
;
	I32	y = (I32)SvIV(ST(1))
;
#line 1440 "FastSOM.xs"
	SV* rv;
#line 1974 "FastSOM.c"
	SV *	RETVAL;
#line 1442 "FastSOM.xs"
	rv = _array_FETCH(self, y);
	ST(0) = rv;
	sv_2mortal(ST(0));
#line 1980 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__ARRAY_FETCHSIZE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__ARRAY_FETCHSIZE)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1450 "FastSOM.xs"
	IV rv;
#line 1997 "FastSOM.c"
	IV	RETVAL;
	dXSTARG;
#line 1452 "FastSOM.xs"
	rv = (INT2PTR(SOM_Array*,self2iv(self)))->Y;
	XSprePUSH; PUSHi((IV)rv);
#line 2003 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__ARRAY_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__ARRAY_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	obj = ST(0)
;
#line 1459 "FastSOM.xs"
	I32* temp;
#line 2022 "FastSOM.c"
#line 1461 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_array_DESTROY(obj);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
        }
	return;
#line 2031 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__VECTOR_STORE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__VECTOR_STORE)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, z, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0)
;
	I32	z = (I32)SvIV(ST(1))
;
	NV	val = (NV)SvNV(ST(2))
;
#line 1482 "FastSOM.xs"
	I32* temp;
#line 2055 "FastSOM.c"
#line 1484 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_vector_STORE(self, z, val);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
        }
	return;
#line 2064 "FastSOM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__VECTOR_FETCH); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__VECTOR_FETCH)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, z");
    {
	SV *	self = ST(0)
;
	I32	z = (I32)SvIV(ST(1))
;
#line 1497 "FastSOM.xs"
	SV* rv;
#line 2084 "FastSOM.c"
	SV *	RETVAL;
#line 1499 "FastSOM.xs"
	rv = _vector_FETCH(self, z);
	ST(0) = rv;
	sv_2mortal(ST(0));
#line 2090 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__VECTOR_FETCHSIZE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__VECTOR_FETCHSIZE)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 1507 "FastSOM.xs"
	IV rv;
#line 2107 "FastSOM.c"
	IV	RETVAL;
	dXSTARG;
#line 1509 "FastSOM.xs"
	rv = (INT2PTR(SOM_Vector*,self2iv(self)))->Z;
	XSprePUSH; PUSHi((IV)rv);
#line 2113 "FastSOM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_AI__NeuralNet__FastSOM__VECTOR_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_AI__NeuralNet__FastSOM__VECTOR_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "obj");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	obj = ST(0)
;
#line 1516 "FastSOM.xs"
	I32* temp;
#line 2132 "FastSOM.c"
#line 1518 "FastSOM.xs"
	temp = PL_markstack_ptr++;
	_vector_DESTROY(obj);
	if (PL_markstack_ptr != temp) {
		PL_markstack_ptr = temp;
		XSRETURN_EMPTY;
        }
	return;
#line 2141 "FastSOM.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_AI__NeuralNet__FastSOM); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_AI__NeuralNet__FastSOM)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("AI::NeuralNet::FastSOM::train", XS_AI__NeuralNet__FastSOM_train);
        newXS_deffile("AI::NeuralNet::FastSOM::bmu", XS_AI__NeuralNet__FastSOM_bmu);
        newXS_deffile("AI::NeuralNet::FastSOM::map", XS_AI__NeuralNet__FastSOM_map);
        newXS_deffile("AI::NeuralNet::FastSOM::output_dim", XS_AI__NeuralNet__FastSOM_output_dim);
        newXS_deffile("AI::NeuralNet::FastSOM::_adjust", XS_AI__NeuralNet__FastSOM__adjust);
        newXS_deffile("AI::NeuralNet::FastSOM::STORABLE_freeze", XS_AI__NeuralNet__FastSOM_STORABLE_freeze);
        newXS_deffile("AI::NeuralNet::FastSOM::STORABLE_thaw", XS_AI__NeuralNet__FastSOM_STORABLE_thaw);
        newXS_deffile("AI::NeuralNet::FastSOM::FETCH", XS_AI__NeuralNet__FastSOM_FETCH);
        newXS_deffile("AI::NeuralNet::FastSOM::STORE", XS_AI__NeuralNet__FastSOM_STORE);
        newXS_deffile("AI::NeuralNet::FastSOM::FIRSTKEY", XS_AI__NeuralNet__FastSOM_FIRSTKEY);
        newXS_deffile("AI::NeuralNet::FastSOM::NEXTKEY", XS_AI__NeuralNet__FastSOM_NEXTKEY);
        newXS_deffile("AI::NeuralNet::FastSOM::DESTROY", XS_AI__NeuralNet__FastSOM_DESTROY);
        newXS_deffile("AI::NeuralNet::FastSOM::Rect::new", XS_AI__NeuralNet__FastSOM__Rect_new);
        newXS_deffile("AI::NeuralNet::FastSOM::Rect::neighbors", XS_AI__NeuralNet__FastSOM__Rect_neighbors);
        newXS_deffile("AI::NeuralNet::FastSOM::Rect::radius", XS_AI__NeuralNet__FastSOM__Rect_radius);
        newXS_deffile("AI::NeuralNet::FastSOM::Torus::neighbors", XS_AI__NeuralNet__FastSOM__Torus_neighbors);
        newXS_deffile("AI::NeuralNet::FastSOM::Hexa::new", XS_AI__NeuralNet__FastSOM__Hexa_new);
        newXS_deffile("AI::NeuralNet::FastSOM::Hexa::neighbors", XS_AI__NeuralNet__FastSOM__Hexa_neighbors);
        newXS_deffile("AI::NeuralNet::FastSOM::Utils::vector_distance", XS_AI__NeuralNet__FastSOM__Utils_vector_distance);
        newXS_deffile("AI::NeuralNet::FastSOM::MAP::FETCH", XS_AI__NeuralNet__FastSOM__MAP_FETCH);
        newXS_deffile("AI::NeuralNet::FastSOM::MAP::FETCHSIZE", XS_AI__NeuralNet__FastSOM__MAP_FETCHSIZE);
        newXS_deffile("AI::NeuralNet::FastSOM::MAP::DESTROY", XS_AI__NeuralNet__FastSOM__MAP_DESTROY);
        newXS_deffile("AI::NeuralNet::FastSOM::ARRAY::STORE", XS_AI__NeuralNet__FastSOM__ARRAY_STORE);
        newXS_deffile("AI::NeuralNet::FastSOM::ARRAY::FETCH", XS_AI__NeuralNet__FastSOM__ARRAY_FETCH);
        newXS_deffile("AI::NeuralNet::FastSOM::ARRAY::FETCHSIZE", XS_AI__NeuralNet__FastSOM__ARRAY_FETCHSIZE);
        newXS_deffile("AI::NeuralNet::FastSOM::ARRAY::DESTROY", XS_AI__NeuralNet__FastSOM__ARRAY_DESTROY);
        newXS_deffile("AI::NeuralNet::FastSOM::VECTOR::STORE", XS_AI__NeuralNet__FastSOM__VECTOR_STORE);
        newXS_deffile("AI::NeuralNet::FastSOM::VECTOR::FETCH", XS_AI__NeuralNet__FastSOM__VECTOR_FETCH);
        newXS_deffile("AI::NeuralNet::FastSOM::VECTOR::FETCHSIZE", XS_AI__NeuralNet__FastSOM__VECTOR_FETCHSIZE);
        newXS_deffile("AI::NeuralNet::FastSOM::VECTOR::DESTROY", XS_AI__NeuralNet__FastSOM__VECTOR_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
